const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const work_order_operations = sequelize.define(
    'work_order_operations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"ready",


"in_progress",


"paused",


"completed",


"blocked"

        ],

      },

scheduled_start_at: {
        type: DataTypes.DATE,
      
      

      },

scheduled_end_at: {
        type: DataTypes.DATE,
      
      

      },

started_at: {
        type: DataTypes.DATE,
      
      

      },

ended_at: {
        type: DataTypes.DATE,
      
      

      },

good_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

operator_notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  work_order_operations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























    db.work_order_operations.hasMany(db.inspections, {
      as: 'inspections_work_order_operation',
      foreignKey: {
          name: 'work_order_operationId',
      },
      constraints: false,
    });







//end loop



    db.work_order_operations.belongsTo(db.production_orders, {
      as: 'production_order',
      foreignKey: {
        name: 'production_orderId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.operations, {
      as: 'operation',
      foreignKey: {
        name: 'operationId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.machines, {
      as: 'assigned_machine',
      foreignKey: {
        name: 'assigned_machineId',
      },
      constraints: false,
    });

    db.work_order_operations.belongsTo(db.users, {
      as: 'assigned_user',
      foreignKey: {
        name: 'assigned_userId',
      },
      constraints: false,
    });




    db.work_order_operations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.work_order_operations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return work_order_operations;
};


